% 15 October, 2012
% Gabor Pinter

%%%%%%%%%%%%%%%%%%%%%%%%%
% Wold-MA format of the estimated matrix

function [cimpu wimpu] = wold(BB,Sigma, n, nlagsimp)

% xx    = size(BB,1);
% wimpu = zeros(xx,xx,nlagsimp);
% cimpu = wimpu;

for j=1:nlagsimp
    %% (non-orthogonal) Wold impulses
        if j == 1
            wimpu(:,:,j) = eye(size(BB,1),size(BB,2));
        elseif j > 1
            wimpu(:,:,j) = BB^(j-1);
        end
        %% (orthogonal) Choleski impulses
        cimpu(:,:,j) = wimpu(1:n,1:n,j) * chol(Sigma)';
end


